package jumbo.xml;

import java.applet.Applet;

import java.net.MalformedURLException;

/** the 'toplevel' container for jumbo.xml routines and the one that
a user meets first.
@author P.Murray-Rust, 1998
*/
public class Jumbo extends Applet {
	SAX sax;
	XTree xTree;
	String urlString = null;
// AElfred is default
	String parserClassName = SAX.parserTypeStrings[SAX.AELFRED];
	
	public Jumbo() {
		super();
	}

	public void init() {
// make sure we know Jumbo is running as an applet
		Util.registerApplet(this);
		System.out.println("Jumbo init()ed...");
		String commandLine = this.getParameter("COMMANDLINE");
		System.out.println("args: "+commandLine);
		String[] args = Util.split(commandLine);
		if (args == null) {
			System.out.println("No args given");
			return;
		}
		try {
			interpretArgs(args);
		} catch (XException e) {
			System.out.println("Error: ");
			e.printStackTrace();
		}
	}

	void interpretArgs(String[] args) throws XException {
		if (args.length == 1) {
			if (args[0].toLowerCase().equals("-h")) {
				System.out.println("Usage: java  jumbo.xml.Jumbo -h (this message)");
				System.out.println("Usage: java  jumbo.xml.Jumbo  [file/URL]");
				return;
			}
		}
		if (args.length == 0) {
			xTree = new XTree("Dummy");
		} else {
			urlString = args[0];
			try {
				urlString = Util.makeAbsoluteURL(this, urlString);
			} catch (MalformedURLException mue) {
				throw new XException(mue);
			}
			System.out.println("Parsing: "+urlString+" with: "+parserClassName);
			sax = new SAX(urlString, parserClassName);
			xTree = sax.getTree();
		}
  	    XTreeOptions options = new XTreeOptions();
	    options.displayType = XTreeOptions.SPLITPANE;
	    options.omitWhitespace = true;
	    xTree.setOptions(options);
		xTree.display();
	}

/** use to launch Jumbo as an application */
	public static void main(String[] args) {
		Jumbo jumbo = null;
		try {
			jumbo = new Jumbo();
			jumbo.interpretArgs(args);
		} catch (Exception e) {e.printStackTrace(); System.exit(0);}
	}
}
